"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PQueue = void 0;
const PQueueEnqueuOptimizedMin_1 = require("./PQueueEnqueuOptimizedMin");
const PQueueEnqueuOptimizedMax_1 = require("./PQueueEnqueuOptimizedMax");
const PQueueDequeueOptimizedMin_1 = require("./PQueueDequeueOptimizedMin");
const PQueueDequeueOptimizedMax_1 = require("./PQueueDequeueOptimizedMax");
class PQueue {
    constructor(options) {
        if ((options === null || options === void 0 ? void 0 : options.optimization) === "dequeue") {
            this._internalQueue =
                (options === null || options === void 0 ? void 0 : options.type) === "min"
                    ? new PQueueDequeueOptimizedMin_1.PQueueDequeueOptimizedMin()
                    : new PQueueDequeueOptimizedMax_1.PQueueDequeueOptimizedMax();
        }
        else {
            this._internalQueue =
                (options === null || options === void 0 ? void 0 : options.type) === "min"
                    ? new PQueueEnqueuOptimizedMin_1.PQueueEnqueuOptimizedMin()
                    : new PQueueEnqueuOptimizedMax_1.PQueueEnqueuOptimizedMax();
        }
    }
    enQueue(value, priority) {
        this._internalQueue.enQueue(value, priority);
    }
    deQueue() {
        return this._internalQueue.deQueue();
    }
}
exports.PQueue = PQueue;
